'encoding UTF-8  Do not remove or change this line!
'*******************************************************************************
'*
'*  $RCSfile: f_basic_macros.inc,v $
'*
'*  $Revision: 1.3 $
'*
'*  last change: $Author: jsk $ $Date: 2005/06/23 13:38:37 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/******************************************************************************
' **
' ** owner : joerg.skottke@sun.com
' **
' ** short description : check macro-dialogs / BASIC-IDE ( 1. part )
' **
'*******************************************************************************
' **
' #1 tMakro_In_All_Apps               ' open BASIC-IDE in all Applications
' #1 tMakro_Dialog                    ' update-test for macro-dialog
' #1 tMakro_Names                     ' check naming convention for modules
' **
'\******************************************************************************


testcase tMakro_In_All_Apps

    dim brc as boolean
    dim cApp as string
    dim i as Integer
    dim bBug as Boolean
    bBug = FALSE
    
    '///<ul>

    for i=1 to 7

        cApp = hNumericDoctype( i )
        printlog( cApp )

        
        '///<li>open a new document</li>
        printlog( "Open a new document" )
        call hNewDocument()
        
        '///<li>Open the BASIC Macro Organizer</li>
        brc = hOpenBasicOrganizerFromDoc()
        if ( not brc ) then
            warnlog( "Could not open the BASIC Macro Organizer, aborting" )
            call hCloseDocument()
            goto endsub
        endif
        
        '///<li>Create a new module for the current document</li>
        printlog( "Create a n ew module for the current document" )
        brc = hCreateModuleForDoc()
        if ( not brc ) then
            warnlog( "Creating a new module for the current document failed." )
            Kontext "Makro"
            Makro.cancel()
            call hCloseDocument()
            goto endsub
        endif


        '///<li> close the BASIC-IDE</li>
        sleep(1)
        printlog "close the BASIC-IDE"
        FileClose                                         ' close the BASIC IDE
        sleep(1)

        kontext "navigator"
        if Navigator.Exists(5) then
            Navigator.Close
        endif
        '///<li> close the changed document ( a messagebox should warn you about changes, if not it is a bug! )</li>
        sleep(1)
        FileClose                                         ' close the document with new Basic
        sleep(1)
        printlog "close the changed document => a messagebox should warn you about changes!"

        kontext "messagebox"

        if MessageBox.Exists( 1 ) then
            MessageBox.No
        else
            warnlog "A new module is inserted for this document ( " + gApplication  + ", but no messagebox at closing the doc! => BUG"
        end if

    next i

    '///<li>in a math-document tools/macro must be disabled</li></ul>
endcase

'*******************************************************************************

testcase tMakro_Dialog

    '///<h1>Touch some macro related dialogs, work with libraries (.xlb)</h1>
    '///<ul>
    
    dim brc as boolean
    dim iPos as integer
    dim iTemp as integer
    dim i as Integer
    dim XLBFILE as String
    XLBFILE = gTesttoolPath & "framework\basic\input\AppLibrary1\script.xlb"
    
    
    gApplication = "Writer"
    '///<li>Open a new document</li>
    printlog( "Open a new document" )
    Call hNewDocument()
    
    
    brc = hOpenBasicOrganizerFromDoc()
    if ( not brc ) then
        warnlog( "Could not open the BASIC Macro Organizer, aborting" )
        call hCloseDocument()
        goto endsub
    endif
        
    '///<li>Create a new module for the current document</li>
    printlog( "Create a n ew module for the current document" )
    brc = hCreateModuleForDoc()
    if ( not brc ) then
        warnlog( "Creating a new module for the current document failed." )
        Kontext "Makro"
        Makro.cancel()
        call hCloseDocument()
        goto endsub
    endif
    
    sleep( 2 )
    kontext "BasicIDE"
    FileClose
    
    brc = hOpenBasicOrganizerFromDoc()

    '///<li>tools / macro and select the new module</li>
    printlog( "Select the last Module for the current document" )
    iPos = hSelectTheLastNode( MakroAus )
    
    '///<li>organize</li>
    printlog( "Organize" )
    Verwalten.Click()
    
    kontext
    '///<li>activate TabModule on it 'New Module' / 'New Dialog'</li>
    printlog( "Activate TabModule" )
    Active.SetPage( TabModule )

    kontext "tabmodule"
    '///<li>create a new module</li>
    printlog( "Press 'new module'" )
    NeuesModul.Click()

    kontext "neuesmodul"
    '///<li>cancel the 'New Module' dialog</li>
    printlog( "Cancel the dialog" )
    NeuesModul.Cancel()


    kontext
    '///<li>create a 'New Dialog'</li>
    active.setpage( TabDialogs )

    kontext "tabdialogs"
    printlog( "Press 'new dialog'" )
    NewDialog.Click()
    
    
    kontext "neuerdialog"
    '///<li>cancel the dialog</li>
    printlog( "Cancel the dialog" )
    NeuerDialog.Cancel()

    kontext
    '///<li>activate TabLibrary on it 'New' / 'Password' / 'Delete' / 'Append' / 'Edit'</li>
    printlog( "Select the libraries Tab" )
    Active.SetPage( TabBibliotheken )

    kontext "tabbibliotheken"
    '///<li>press 'New' on the libraries tab</li>
    printlog( "Press 'New' on the libraries tab" )
    Neu.Click()

    kontext "neuebibliothek"
    '///<li>close the dialog with 'OK'</li>
    printlog( "Close the dialog with 'OK'" )
    Call DialogTest( NeueBibliothek )
    NeueBibliothek.OK()
    
    '///<li>delete the new default library</li>
    printlog( "Delete 'Library1'" )

    kontext "tabbibliotheken"
    Loeschen.Click()
    '///<li>close the warning</li>
    printlog( "Close the warning" )

    kontext "active"
    if ( Active.Exists() ) then
        Active.Yes()
    else
        warnlog( "Expected confirmation dialog for delete" )
    endif
  

    kontext "tabbibliotheken"
    printlog( "Check the number of libraries in list" )
    iTemp = Bibliotheksliste.getItemCount()
    if ( iTemp <> 1 ) then
        warnlog( "There should only be 1 library listed, there are " & iTemp )
    endif

    kontext "tabbibliotheken"
    '///<li>Append a library by pressing 'Append'</li>
    printlog( "Append a xlb-file" )
    Hinzufuegen.Click()

    kontext "oeffnendlg"
    '///<li>select a valid library and open it</li>
    printlog( "Select 'AppLibrary1/script.xlb' from the files list" )
    Dateiname.SetText( ConvertPath ( XLBFILE ) )
    Oeffnen.Click()
    sleep(2)

    kontext "appendlibraries"
    Call DialogTest( AppendLibraries )
    '///<li>Make sure 'Insert as Reference' is unchecked</li>
    printlog( "Ensure 'Insert as Reference' is unchecked" )

    kontext "appendlibraries"

    if ( InsertAsReference.IsChecked() ) then
        InsertAsReference.UnCheck()
    end if

    '///<li>check 'Replace Existing Library'</li>
    printlog( "Check 'Replace existing library'" )

    if ( not ReplaceExistingLibraries.IsChecked() ) then
        ReplaceExistingLibraries.Check()
    end if

    kontext "appendlibraries"
    '///<li>press 'OK' to append the library</li>
    printlog( "Press 'OK' to append the library" )
    AppendLibraries.OK()
    sleep( 1 )

    kontext "tabbibliotheken"
    printlog( "Check the number of libraries in list" )
    iTemp = Bibliotheksliste.getItemCount()
    if ( iTemp <> 2 ) then
        warnlog( "Two entries in list expected, found " & iTemp )
    endif

    printlog( "Select the first item" )
    Bibliotheksliste.TypeKeys( "<HOME>" )
    '///<li>Select 'AppLibrary1' and click 'Password'</li>

    for i = 1 to iTemp 
        if ( Bibliotheksliste.getSelText() = "AppLibrary1" ) then
            printlog( "Found AppLibrary1" )
            exit for
        endif
        printlog( "This was not AppLibrary1, trying again" )
        Bibliotheksliste.Typekeys( "<DOWN>" )
    next i
    
    
    kontext "tabbibliotheken"
    printlog( "Set a password for AppLibrary1" )
    if ( Passwort.IsEnabled() ) then
        Passwort.Click()
        kontext "passwddlg"
        PasswdDLG.Cancel()
    else
        warnlog( "Password is disabled for 'AppLibrary1'" )
    endif


    '///<li>delete the inserted library</li>
    printlog( "Delete 'AppLibrary1'" )

    kontext "tabbibliotheken"
    Loeschen.Click()
    '///<li>close the warning</li>
    printlog( "Close the warning" )

    kontext "active"
    if ( Active.Exists() ) then
        Active.Yes()
    else
        warnlog( "Expected confirmation dialog for delete" )
    endif
    
    
    '///<li>after edit the Basic-IDE must be open</li>
    '///<li>close it</li>

    kontext "tabbibliotheken"
    printlog( "Press 'edit' on 'Libraries'-tab" )
    Bearbeiten.Click()

    kontext "BasicIDE"
    if ( BasicIDE.Exists( 5 ) ) then
    
        EditWindow.typeKeys( "'get the focus" )
    
        '///<li>Close the basic IDE</li>
        printlog( "Close the basic-document" )
        FileClose

        kontext "active"
        if ( Active.Exists ( 2 ) ) then
            warnlog( Active.getText() )
            printlog( "The file should be saved without confirmation" )
            Active.NO()
        endif

    else
        warnlog("#i38978# The Macro-Document is not open, aborting test")
        call hCloseDocument()
        goto endsub
    endif

    '///<li>Open the BASIC Macro Organizer</li>
    printlog( "Open the BASIC Macro Organizer" )
    brc = hOpenBasicOrganizerFromDoc()
    
    kontext "makro"
    '///<li>go to the last macro in the list</li>
    printlog( "Select the last macro from the list" )
    iPos = hSelectTheLastNode( MakroAus )
    
    '///<li>organize</li>
    printlog( "Press 'Organize'" )
    try
        '///<li>Assign the macro by pressing 'Assign'</li>
        printlog( "Assign the macro" )
        Zuordnen.Click ()
    catch
        warnlog( "#i106853# Assign-Button is disabled or macro is missing" )
    endcatch
    
    printlog( "We should be on the macro-assignament dialog" )

    '///<li>activate all tapages and cancel the tabdialog</li>
    printlog( "Activate all tabpages and cancel the tabdialog" )

    kontext
    Active.SetPage( TabCustomizeMenu )
    Active.SetPage( TabCustomizeToolbars )
    Active.SetPage( TabCustomizeEvents )
    Active.SetPage( TabTastatur )
    
    kontext "tabtastatur"
    TabTastatur.Cancel()
    
    kontext "makro"
    '///<li>run</li>
    printlog "Run"
    try
        Ausfuehren.Click()
    catch
        warnlog( "Unable to run macro" )
        kontext "Makro"
        Makro.close()
    endcatch
    sleep(3)
    
    
    '///tools / macro
    brc = hOpenBasicOrganizerFromDoc()
    brc = hSelectTheLastNode( MakroAus )


    printlog "Delete the new module"
    Loeschen.Click()
    '///<li>close the warning</li>
    printlog( "Close the warning" )

    kontext "active"
    if ( active.exists() ) then
        Active.Yes()
    else
        warnlog( "No confirmation dialog for delete" )
    endif
    '///<li>close the macro dialog</li>
    printlog( "Close the macro dialog" )

    kontext "makro"
    Makro.Close()
    
    '///<li>Close the document</li>
    printlog( "Close the document" )
    Call hCloseDocument()
    
    '///</ul>
endcase

'*******************************************************************************

testcase tMakro_Names

    dim iPos as integer
    dim brc as boolean
    Dim iCurrentName as Integer
    Dim sSeperator as String
    '///check the name conventions for modules
    '///<ul><li>open a new writer document</li>
    printlog "open a new writer-doc"
    gApplication = "Writer"
    Call hNewDocument
    
    '///<li>Open the BASIC Macro Organizer</li>
    brc = hOpenBasicOrganizerFromDoc()
    if ( not brc ) then
        warnlog( "Could not open the BASIC Macro Organizer, aborting" )
        call hCloseDocument()
        goto endsub
    endif     
    
    '///<li>Select the last module (Document BASIC)</li>
    iPos = hSelectTheLastNode( MakroAus )
    if ( not Neu.isEnabled() ) then
        warnlog( "New button is disabled for the current module, aborting" )
        kontext "Makro"
        Makro.cancel()
        call hCloseDocument()
        goto endsub
    endif
    
    Neu.Click

    for iCurrentName = 1 to 13

        select case iCurrentName
        case 1  : sSeperator = "-"
        case 2  : sSeperator = "."
        case 3  : sSeperator = ","
        case 4  : sSeperator = "+"
        case 5  : sSeperator = ":"
        case 6  : sSeperator = "!"
        case 7  : sSeperator = "$"
        case 8  : sSeperator = "("
        case 9  : sSeperator = ")"
        case 10 : sSeperator = "="
        case 11 : sSeperator = "?"
        case 12 : sSeperator = "*"
        case 13 : sSeperator = " "
        end select

        '///<li>click new and insert 'tt?module' with forbidden signes</li>
        '///<li>- tested forbidden signes are ( only one for each test name ) :</li>
        '///<li>- '-', '.', ',', '+', ':', '!', '$', '(', ')', '=', '?', '*', ' '</li>
        '///<li>=> '?' is not allowed => a messagebox must come up => OK</li>
        printlog(  "- insert 'tt" & sSeperator & _
                   "module' and click OK => warning box must come up => OK" )

        kontext "neuesmodul"
        Modulname.SetText( "tt" & sSeperator & "module" )
        NeuesModul.OK()

        kontext "active"

        if ( Active.Exists() ) then
            Active.OK()

            kontext "neuesmodul"
        else
            warnlog( "tt" & sSeperator & "module can be created => BUG : '" & _
                      sSeperator & "' in module names are not allowed!" )

            kontext "makro"
            if ( Makro.Exists() ) then
                Macro.Close()
            endif

            kontext "basicide"

            if ( EditWindow.Exists() ) then
                Call hCloseDocument()
            end if

            goto endsub    ' if an error occured => testcase ends
        end if

    next iCurrentName

    '///<li>close the naming dialog</li>
    kontext "neuesmodul"
    if ( NeuesModul.Exists() ) then
        NeuesModul.Cancel()
    endif

    '///<li>close the macro dialog</li>
    kontext "makro"
    if ( Makro.Exists() ) then
        Makro.Close()
    endif
    
    '///<li>close the last document</li></ul>
    Call hCloseDocument()
    
endcase


