'encoding UTF-8  Do not remove or change this line!
'*******************************************************************************
'*
'*  $RCSfile: f_basic_modulenames.inc,v $
'*
'*  $Revision: 1.6 $
'*
'*  last change: $Author: jsk $ $Date: 2005/07/22 12:07:06 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/******************************************************************************
'*
'*  owner : joerg.skottke@sun.com
'*
'*  short description : Test modulenames on the tabbar
'*
'*******************************************************************************
'**
' #1 tBasicIdeModuleNames ' Test modulenames on the tabbar
'**
'\******************************************************************************

testcase tBasicIdeModuleNames

    '///<h1>Naming conventions in BASIC-IDE module-/dialog-tabs</h1>

    dim cDefaultTabName as string
    dim rc as integer
    dim brc as boolean

    gApplication = "Writer"
    call hNewDocument()

    ' ------ prerequisites ---------
    
    '///<ul>
    '///<li>Create a new module for the current (writer) document</li>
    brc = hOpenBasicOrganizerFromDoc()
    brc = hCreateModuleForDoc()
    if ( not brc ) then
        warnlog( "Could not create a new module for the document, aborting" )
        kontext "Makro"
        Makro.cancel()
        call hCloseDocument()
        goto endsub
    endif
   
    rc = hInsertMacro( 1 )
    if ( rc <> 0 ) then
       warnlog( "Failed to insert macro" )
    endif
   
    '///<li>Verify that the name makes it to the BASIC macro organizer</li>
    cDefaultTabName = hGetTabNameFromOrganizer()

    ' ------ begin test --------    
    
    
    '///<li>Try to name the tab something containing whitespace (should fail)</li>
    rc = hRenameTab( "ttModule X" )
    if ( rc = 1 ) then
       printlog( " * Warning for invalid tab-name. Good." )
       kontext "active"
       active.ok()
       
       kontext "basicide"
       tabbar.typekeys( "<ESCAPE>" , true )       
    else
       warnlog( "Warning missing for names containing spaces" )
       printlog( "rc = " & rc )
    endif
    
    
    '///<li>Try to name the tab something that contains - (minus), (should fail)</li>
    rc = hRenameTab( "tt-ModuleX" )
    if ( rc = 1 ) then
       printlog( " * Warning for invalid tab-name. Good." )
       kontext "active"
       active.ok()
       
       kontext "basicide"
       tabbar.typekeys( "<ESCAPE>" , true )
    else
       warnlog( "Warning missing for names containing - (minus)" )
       printlog( "rc = " & rc )
    endif
    
    
    '///<li>Try to name the tab to the current name (should work)</li>
    rc = hRenameTab( cDefaultTabName )
    if ( rc = 0 ) then
       printlog( " * Renaming tab succeeded" )
    else
       warnlog( "Renaming Tab failed" )
       active.ok()
       
       kontext "basicide"
       tabbar.typekeys( "<ESCAPE>" , true )       
    endif

    
    '///<li>Finally try to give the tab a valid name (should work)</li>
    rc = hRenameTab( "GoodName" )
    if ( rc = 0 ) then
       printlog( " * Renaming tab succeeded" )
    else
       warnlog( "Renaming Tab failed" )
       active.ok()
       
       kontext "basicide"
       tabbar.typekeys( "<ESCAPE>" , true )       
    endif
    
    
    '///<li>Verify that we are still in the same IDE-Window</li>
    rc = hTestMacro( 1 )
    if ( rc = 0 ) then
        printlog( " * the correct macro-module is still open. Good." )
    else
        warnlog( "The open macro-module is not the one that was expected" )
    endif
    
    '///<li>Close IDE and document</li>
    hCloseBasicIDE()
    
    call hCloseDocument()
    '///</ul>

endcase


