'encoding UTF-8  Do not remove or change this line!
'*******************************************************************************
'*
'*  $RCSfile: help.inc,v $
'*
'*  $Revision: 1.4 $
'*
'*  last change: $Author: jsk $ $Date: 2004/08/04 13:51:59 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/******************************************************************************
'*
'* owner : joerg.skottke@sun.com
'*
'* short description : 
'*
'*******************************************************************************
' **
' #1 tCheckAboutItems    ' gets the list of about-items 
' #1 tHelpRessourceTest  ' travels through the index and loads all pages.
' **
'\******************************************************************************

testcase tCheckAboutItems( iAboutItems as integer )

   dim iItem as integer
   dim cItem as string
   const ICWAIT as Integer = 1
   
   '///<h3>Check the itemcount in the about-box</h3>
   '///<ul>

   '///<li>Open Help</li>
   call hOpenHelp()
   sleep( ICWAIT * 5 )

   Kontext "StarOfficeHelp"

   '///<li>Select index-tab</li>
   TabControl.SetPage( Indexpage )
   sleep( ICWAIT )

   '///<li>get the number of applications from the drop down box</li>
   iAboutItems = HelpAbout.getItemCount()
   printlog( "" )
   printlog( " * About-Multilistbox contains " & iAboutItems & " topics" )
   
   '<li>get the list of items from the multilistbox, count the items listed
   ' in the index for every 'About-Item'
   for iItem = 1 to iAboutItems
      cItem = HelpAbout.getItemText( iItem )
      HelpAbout.Select( iItem )
      sleep( ICWAIT * 5 )
      iItem = SearchIndex.getItemCount()
      printlog( " * " & cItem & " has " & iItem & " entries" )
   next iItem
   
   printlog( " " )

   '///<li>close help</li>
   call hCloseHelp()
   '///</ul>
   
endcase

'*******************************************************************************

testcase tHelpRessourceTest( iCurrentAboutItem as integer )

   const ICWAIT as Integer = 1
   dim iTopicCount as integer
   dim iAboutItems as integer
   dim iCurrentTopic as integer
   dim cCurrentTopic as integer
   dim cCurrentAboutItem as string
   
   '///<h3>Ressourcetest for OpenOffice.org help viewer</h3>
   '///<ul>
   '///<li>Open help</li>
   call hOpenHelp()
   sleep( ICWAIT * 5 )

   Kontext "StarOfficeHelp"

   '///<li>Select index-tab</li>
   TabControl.SetPage( Indexpage )
   sleep( ICWAIT )

   '///<li>get the number of applications from the drop down box</li>
   iAboutItems = HelpAbout.getItemCount()

   '///<li>set and printout the current application for which to display the index</li>
   HelpAbout.select( iCurrentAboutItem )
   sleep( ICWAIT )

   '///<li>retrieve the text from the Multilistbox</li>
   cCurrentAboutItem = HelpAbout.getSelText()
   printlog( " " )
   printlog( " * Current Application: " & cCurrentAboutItem )

   '///<li>get number of entries in combo-box (help topics)</li>
   iTopicCount = SearchIndex.getItemcount()
   sleep( ICWAIT )
   printlog( " * reading " & iTopicCount & " entries" )
   printlog( " " )

   '///<li>open every item in the index, one by one</li>
   for iCurrentTopic = 1 to iTopicCount 

      try
         '///<li>select one item from the list</li>
         SearchIndex.Select( iCurrentTopic )
         wait( 500 )
         cCurrentTopic = SearchIndex.getItemText()

         '///<li>press the "Display" button</li>
         DisplayIndex.click()
      catch
         warnlog( "Failed to select entry at " & iCurrentTopic _
                  & " : " & cCurrentTopic )
         goto breaktest ' brutally kill the test.
      endcatch

   next iCurrentTopic

   breaktest:
   
   '///<li>close help</li>
   call hCloseHelp()
   
   call ExitRestartTheOffice()
   '///</ul>
   
endcase

'-------------------------------------------------------------------------

sub hOpenHelp

   Dim i as integer

   HelpContents

   Kontext "StarOfficeHelp"
   for i = 1 to 50
      If( StarOfficeHelp.Exists() <> TRUE ) then
         sleep( 1 )
      else
         printlog( CHR$(13) & " * It takes " & i & " seconds to show the help!")
         i = 51
      end if
   next i

end sub

'-------------------------------------------------------------------------

sub hCloseHelp

   Kontext "StarOfficeHelp"
   if( NOT StarOfficeHelp.Exists( 5 )) then
      warnlog( "Help is not open." )
   else
      StarOfficeHelp.TypeKeys( "<MOD1 F4>" )    ' <CTRL>+<F4>
      sleep( 7 )
      if( StarOfficeHelp.Exists( 5 ) ) then
         printlog( "Help still open." )
      end if
   end if

end sub

