'encoding UTF-8  Do not remove or change this line!
'*******************************************************************************
'*
'*  $RCSfile: f_inst_langswitch.inc,v $
'*
'*  $Revision: 1.5 $
'*
'*  last change: $Author: jsk $ $Date: 2005/02/09 14:33:06 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/******************************************************************************
'*
'*  owner : joerg.skottke@sun.com
'*
'*  short description : Test switching UI-languages
'*
'*******************************************************************************
'**
' #1 tLangSwitch ' Test switching UI-languages
'**
'\******************************************************************************

testcase tLangSwitch

    dim clLangList( 30 ) as string    ' list containg the installed languages
    dim clLangScheme( 30 ) as string  ' list containing the localized language-names
    
    ' this is where the reference files will be written to
    dim cSavePath as string
        cSavePath = gOfficePath & "user\work" 
        cSavePath = convertpath( cSavePath )
      
    ' this is where the input files are located
    dim cLoadPath as string
        cLoadPath = "framework\install\input\langswitch" 
        cLoadPath = convertpath( gTesttoolPath & cLoadPath )

    ' these are some ui-strings taken from various places around the office
    dim cTestStrings( 10 ) as string  ' strings taken from the UI
    dim cRefStrings( 10 ) as string   ' strings that are taken from reference files

    ' integer expressions for languages
    dim iCurrentLang as integer
    dim iLangCount as integer
    dim iLangCast as integer
    dim iStartLanguage as integer
    
    printlog( "" )
    printlog( "Writing new reference-files to: " & cSavePath
    printlog( "Reading reference-files from..: " & cLoadPath
    printlog( "Copy new files from save-path to load-path to use them. " & _
              "Remember to edit the 'uilang'-files, e.g. 01=English (English)."
    printlog( "" )

    iStartLanguage = iSprache

    if ( CREATIONMODE ) then
    
        printlog( "" )
        warnlog ( " ********** CREATION MODE **********" )
        printlog( "" )

        ' create UI-string-list in local workdir (calls hGetLangStrings())
        hSaveLangStrings( cSavePath , iSprache )
            
        ' create the lists in local workdir
        hSaveLangScheme( cSavePath , iSprache )
        
        goto endsub
        
    endif
    
    
    ' load the language-scheme (localized language-names)
    ' the scheme must be loaded initially to set the office into a defined state,
    ' which is: Language switched to the first language in the List. In order to 
    ' do so we need to know the name of the first language since they are in 
    ' alphabetical order.
    hLoadLangScheme( clLangScheme(), cLoadPath, iStartLanguage )

    ' get the number of installed languages and a list of those
    iLangCount = hGetInstalledLanguages( clLangList() )
    
    ' if this is a single language installation, abort the test
    if ( iLangCount = 1 ) then
        printlog( "This is no multi-language installation. Aborting" )
        goto endsub
    endif
    
    listsort( clLangList() )
    
    for iCurrentLang = 1 to iLangCount

        printlog( "" )
        printlog( "Current UI-Language: " & clLangList( iCurrentLang ) )
        
        ' cast string to int (string = "01" -> int = 1)
        iLangCast = val( clLangList( iCurrentLang ) )

        ' switch UI-Language, re-casting int to string
        hSetUILanguage( clLangScheme() , iLangCast )
        
        ' load the language-scheme (localized language-names) from file
        hLoadLangScheme( clLangScheme(), cLoadPath, iLangCast )        

        ' load the reference strings from file
        hLoadLangStrings( cRefStrings() , cLoadPath , iLangCast )
       
        ' gather strings for comparision from the UI
        hGetLangStrings( cTestStrings() ) 
        
        ' compare the lists
        printlog( "Comparing strings" )
        call gCompare2Lists( cRefStrings() , cTestStrings() )
    
   next iCurrentLang 

   printlog( "" )
   printlog( "Reset office to default language" )
   hLoadLangScheme( clLangScheme(), cLoadPath, iSprache )
   hSetUILanguage( clLangScheme() , iStartLanguage )

endcase

'*******************************************************************************

function hSaveLangScheme( cSavePath as string , iLang as integer )
    
    dim iLanguages as integer
    dim iCurrentEntry as integer
    dim cUILangList( 30 ) as string
    dim sFileName as string
                                        
    ToolsOptions
    
    hToolsOptions( "LANGUAGESETTINGS" , "LANGUAGES" )
    
    iLanguages = UILanguage.getItemCount()
    cUILangList( 0 ) = iLanguages
    
    for iCurrentEntry = 1 to iLanguages
    
        UILanguage.select( iCurrentEntry )
        cUILangList( iCurrentEntry ) = UILanguage.getSelText()
    
        printlog( iCurrentEntry & ". : " & cUILangList( iCurrentEntry ) )
        
    next iCurrentEntry
    
    kontext "OptionenDlg"
    OptionenDlg.cancel()
    
    sFileName = cSavePath & "\uilang" & iLang & ".txt"
    sFileName = convertpath( sFileName )
    printlog( "Write UI-Language-Names to " & sFileName )
    listwrite( cUILangList() , sFileName , "UTF8" ) 
                                        
end function

'*******************************************************************************

function hSaveLangStrings( cSavePath as string , iLang as integer )

    dim sFileName as string
    dim cUIStringList( 3 ) as string
        cUIStringList( 0 ) = "3"
    
    hGetLangStrings( cUIStringList() )
    
    sFileName = cSavePath & "\uistrings" & iLang & ".txt"
    sFileName = convertpath( sFileName )
    printlog( "Write UI-Strings-list to " & sFileName )
    listwrite( cUIStringList() , sFileName , "UTF8" )     
    
end function

'*******************************************************************************

function hLoadLangScheme( clLangScheme() as string , _
                               cLoadPath as string , _
                               iLanguage as integer ) as integer
                               
    ' this function reads the languages dependent names of the currently
    ' active UI-Language. (e.g. English UI = German (Germany), German UI=
    ' Deutsch (Deutschland) etc. )
    ' If no reference file exists, the routine defaults to en_US and warns.
    
    ' the file to read
    dim cFile as string
    cFile = cLoadPath & "\uilang" & iLanguage & ".txt"
    cFile = convertpath( cFile )

    ' check if file exists, else use default (en_US)
    if ( dir( cFile ) = "" ) then
        cFile = cLoadPath & "\uilang1.txt"
        cFile = convertpath( cFile )
        warnlog( "Non-localized language-strings in UI-Language selection," & _
                 " using default (en_US)" )
    endif
    
    printlog( "Loading language-scheme from " & cFile )

    ' read in the file (identical to listread ( array, file , "UTF8" ))
    hGetDatafileSection( cFile , clLangScheme() , "" , "" , "" )

    ' return the length of the list 
    hLoadLangScheme() = listcount( clLangScheme )

end function

'*******************************************************************************

function hLoadLangStrings( cRefStrings() as string , _
                               cLoadPath as string , _
                               iLanguage as integer ) as integer
                      
    ' the file to read
    dim cFile as string
    cFile = cLoadPath & "\uistrings" & iLanguage & ".txt"
    cFile = convertpath( cFile )
    
    ' check if file exists, else use default (en_US)
    if ( dir( cFile ) = "" ) then
        cFile = cLoadPath & "\uistrings1.txt"
        cFile = convertpath( cFile )
        warnlog( "Non-localized strings in UI, using default (en_US)" )
    endif
    
    printlog( "Loading UI-Strings from " & cFile )

    ' read in the file (identical to listread ( array, file , "UTF8" ))
    hGetDatafileSection( cFile , cRefStrings() , "" , "" , "" )

    ' return the length of the list 
    hLoadLangStrings() = listcount( cRefStrings() )

end function                      

'******************************************************************************

function hSetUILanguage( clLangScheme() as string, cLanguage as string ) 

    ' this function switches the UI language to a given value. 

    dim cUILanguageName as string

    cUILanguageName = hGetValueForKeyAsString( clLangScheme() , cLanguage )
    printlog( "Setting UI-Language: " & cUILanguageName )

    ' open tools/options
    ToolsOptions
    hToolsOptions( "LANGUAGESETTINGS" , "LANGUAGES" )

    ' select the language
    UIlanguage.select( cUILanguageName )

    ' close options-dialog
    kontext "OptionenDlg"
    OptionenDlg.OK()

    ' there should be a messagebox unless we re-select the current language
    kontext "active"
    if ( active.exists( 1 ) ) then
        active.ok()
    else
        ' if we set the current language as new, there will be no warning.
        if ( iSprache <> val( cLanguage ) ) then
	        warnlog( "Missing warning for UI-Language-Switch" )
	    endif
    endif

    printlog( "Restarting the Office to enable the changes." )
    call exitRestartTheOffice()

end function

'******************************************************************************

function hGetLangStrings( teststring() )

    ' this tiny function gathers three strings from different areas of the
    ' office for comparision.
    
    printlog( "Gathering strings for comparision" )
    
    ' initialize the arry so it can be used by list-functions
    teststring( 0 ) = "3"

    'get the first string (Tools/Options/Office/General/Reset Help agent)
    teststring( 1 ) = hGetTestString1()
    'printlog( " - String (Fixed text): " & teststring( 1 ) )

    ' get the second string (from style-listbox)
    teststring( 2 ) = hGetTestString2()
    'printlog( " - String (Style-Name): " & teststring( 2 ) )

    ' get the third string (Name of 'File' menu)
    teststring( 3 ) = hGetTestString3()
    'printlog( " - String (Menuitem)..: " & teststring( 3 ) )

end function

'******************************************************************************

function hGetTestString1() as string


    ToolsOptions

    hToolsOptions( "STAROFFICE" , "GENERAL" )
   
    'printlog( "Retrieving UI-String: Fixed Text from Tools/Options" )
    hGetTestString1() = TabSonstigesAllgemein.GetFixedText( 2 )

    kontext "OptionenDlg"
    OptionenDlg.cancel()

end function 

'******************************************************************************

function hGetTestString2() as string

    ' this tiny function gets the text from the Style-Combobox on the 
    ' TableObjectBar

    kontext "TableObjectBar"
    
    'printlog( "Retrieving UI-String: Style Combobox on TableObjectBar" )
    hGetTestString2() = vorlage2.getSelText()

end function

'*******************************************************************************

function hGetTestString3() as string

    ' this small function grabs the localized name of the "File" menuitem
    
    kontext "DocumentWriter"
    
    'printlog( "Retrieving UI-String: Name of 'File'-menu" )
    call hUseMenu()
    hGetTestString3() = MenuGetItemText( 1 )

end function
