'encoding UTF-8  Do not remove or change this line!
'*************************************************************************
'*
'*  $RCSfile: install.bas,v $
'*
'*  $Revision: 1.7 $
'*
'*  last change: $Author: jsk $ $Date: 2005/03/23 14:19:10 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/******************************************************************************
'*
'* owner : joerg.skottke@sun.com
'*
'* short description : Test all installed files
'*
'\******************************************************************************

' OFFICEHOME is the location where the office is installed
global OFFICEHOME as string

' TESTHOME is the directory where the input-files are located
global TESTHOME as string

' INSTTYPE is the key which tells the test
' a) whether it is a user or a system-installation
' b) where the reference files are located (special subdirectory)
' c) whether this is an OOo or a StarOffice/StarSuite installation
global INSTTYPE as string

' FILECOUNTLIMIT is the max. number of files allowed in the system-installation
global FILECOUNTLIMIT as integer

' BCREATE = true means the reference lists will be written. Use this only if you 
' are using a local workspace 
global BCREATE as boolean


sub main

   ' testspecific includes
   use "framework\install\inc\install_sysinstall.inc"
   use "framework\install\inc\install_tools.inc"
   use "framework\install\inc\install_file_tools.inc"
   use "framework\install\inc\install_i18n_tools.inc"

   ' global tools for handling of files / Key=Value-pairs / lists
   use "framework\tools\inc\datafile.inc"
   use "framework\tools\inc\key_tools.inc"
   use "framework\tools\inc\arrayfuncs.inc"
   
   ' do not create reference lists by default. If you need to, set this to true
   BCREATE = false

   ' find the path to the office installation. Usually this equals gNetzOfficePath
   OFFICEHOME = gNetzOfficePath()
   
   ' set the prefix for the reference files home-directory
   INSTTYPE = "\sysinst\" & gProductName & "\"

   ' find the path to the testdirectory
   TESTHOME = gTesttoolPath() & "framework\install\input"

   ' set the maximum number of files in the installation directory
   FILECOUNTLIMIT = 15000

   ' start status tracking
   call hStatusIn ( "framework", "install.bas", "Installation file-check" )

   ' the testcase which compares all files within an installation
   call tCheckSystemInstallation

   ' submit status to testtool-database
   call hStatusOut

end sub

'*******************************************************************************

sub LoadIncludeFiles
   use "global\system\inc\master.inc"
   use "global\system\inc\gvariabl.inc"
   GetUseFiles
   gApplication = "WRITER"
end sub
