'encoding UTF-8  Do not remove or change this line!
'*******************************************************************************
'*
'*  $RCSfile: docfuncs.inc,v $
'*
'*  $Revision: 1.13 $
'*
'*  last change: $Author: jsk $ $Date: 2005/07/29 10:29:42 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/******************************************************************************
'*
'* owner : joerg.skottke@sun.com
'*
'* short description : misc functions to handle documents
'*
'*******************************************************************************
' **
' #0 hCloseDocs ' closes all open documents and checks the documentcount
' #0 hUseImpressAutopilot ' enables/disables the autopilot in tools/options
' #0 hCheckDocCount ' check if the correct number of documents is open
' #0 hCloseNavigator ' closes the navigator in writer
' #0 hNumericDocType ' translates a given number to a gApplication
' #0 hNameGen_append ' creates a name that ends on a given char (decimal)
' #0 hNameGen_lead ' creates a name that begins with a given char (decimal)
' #0 hChangeDoc ' changes any documenttype (to trigger document-is-changed-flag)
' #0 exitToolsOptions ' exit Tools/options
' #0 enterToolsOptionsOOoSecurity ' go to the security page
' #0 enterToolsOptionsOOoView ' go to the view page
' #0 hIdentifyDocument ' verify that the correct document has the focus
' **
'\******************************************************************************

function hCloseDocs( iDocCount as integer ) as integer

   ' this function closes a given number of documents. This function 
   ' IS A DIRTY HACK and used in case that you don't really know what happens.
   ' Avoid using it.

   dim iCurrentDoc as integer

   dim iDocsFound  as integer
       iDocsFound = getDocumentCount()

   dim iRealDocCount as integer
       iRealDocCount = iDocCount + 1


   ' check the expected number of documents against the current number
   if ( iDocsFound <> iRealDocCount ) then

      qaerrorlog( "The number of currently open documents is incorrect" )
      printlog( "Expected: " & iRealDocCount )
      printlog( "Found...: " & iDocsFound    )

   endif

   ' now actually close the documents
   for iCurrentDoc = 2 to iDocsFound

      call hCloseDocument()

   next iCurrentDoc


   hCloseDocs() = iDocsFound

end function

'*******************************************************************************

function hUseImpressAutopilot( bEnable as boolean ) as boolean

    '///<h1>Enable/disable the Impress Autopilot in Tools/Options</h1>

    const CFN = "hUseImpressAutopilot::"

    gApplication = "IMPRESS"
    call hNewDocument()

    ToolsOptions
    hToolsOptions( "Presentation" , "General" )

    Kontext "TabSonstigesDraw"

    if ( mitAutopilotStarten.exists() ) then

        if ( bEnable ) then
            mitAutopilotStarten.check()
            printlog( CFN & "Enable Impress Autopilot" )
        else
            mitAutopilotStarten.uncheck()
            printlog( CFN & "Disable Impress Autopilot" )
        endif

    else

        warnlog( "Cannot find Autopilot Checkbox" )

    end if
   
    hUseImpressAutopilot() = mitAutopilotStarten.isChecked()

    Kontext "OptionenDlg"
    OptionenDlg.OK()

    call hCloseDocument()

end function

'*******************************************************************************

function hCheckDocCount( iDocsExpected as integer, bReset as boolean ) as boolean

   '///<h1>Function to verify the correct number of documents is open</h1>
   ' compares the number of open documents against an expected value and
   ' prints an errormessage if expected /= found
   ' if bReset = true the application is reset to recover from the error.

   dim iDocsPresent as integer
       iDocsPresent = getDocumentCount()

   if ( iDocsExpected = iDocsPresent ) then

      hCheckDocCount() = true

   else

      warnlog( "Incorrect document count." )
      printlog( "Expected: " & iDocsExpected )
      printlog( "Found...: " & iDocsPresent  )
      hCheckDocCount() = false

      if ( bReset ) then
         call exitRestartTheOffice()
      endif

   endif

end function

'*******************************************************************************

function hCloseNavigator() as boolean

   '///<h1>Function to close the navigator</h1>
   const CFN = "hCloseNavigator::"

   ' close the navigator if found
   Kontext "Navigator"
   if ( Navigator.Exists() ) then
      printlog( CFN & "Closing Navigator" )
      Navigator.Close()
   end if

   ' verify that the navigator is indeed closed
   Kontext "Navigator"
   if ( Navigator.exists() ) then
       hCloseNavigator() = false
       qaerrorlog( CFN & "Failed to close Navigator, it is still open." )
   else
       hCloseNavigator() = true
   endif

end function

'*******************************************************************************

function hNumericDocType( doctype as integer ) as string

   ' translates a given number into a documenttype (gApplication)

   select case doctype

      case 1 : gApplication = "WRITER"
               hNumericDocType() = "Text document"
      case 2 : gApplication = "CALC"
               hNumericDocType() = "Spreadsheet document"
      case 3 : gApplication = "IMPRESS"
               hNumericDocType() = "Presentation document"
      case 4 : gApplication = "DRAW"
               hNumericDocType() = "Drawing document"
      case 5 : gApplication = "MATH"
               hNumericDocType() = "Formula document"
      case 6 : gApplication = "MASTERDOC"
               hNumericDocType() = "Master document"
      case 7 : gApplication = "HTML"
               hNumericDocType() = "HTML document"
   end select

end function

'*******************************************************************************

function hNameGen_append( iDecChar as long , bSuf as boolean ) as string

   ' returns a filename that contains an ASCII/UNICODE character before the
   ' (optional) dot + suffix
   dim cFile as string
       cFile = "test" & CHR$( iDecChar )

   if ( bSuf = TRUE ) then
      cFile = cFile & hGetSuffix( "current" )
      endif

   hNameGen_append() = cFile

end function

'*******************************************************************************

function hNameGen_lead( iDecChar as long , bSuf as boolean ) as string

   ' returns a filename that contains a leading ASCII/UNICODE character infront
   ' of the optional dot + suffix
   dim cFile as string
       cFile = CHR$( iDecChar ) & "test"

   if ( bSuf = TRUE ) then
      cFile = cFile & hGetSuffix( "current" )
      endif

   hNameGen_lead() = cFile

end function

'*******************************************************************************

function ChangeDoc() as string

    'wrapper for hChangeDoc to maintain compatibility
    qaerrorlog( "Function ChangeDoc() is deprecated. Please call hChangeDoc() instead." )
    ChangeDoc() = hChangeDoc()
    
end function

'*******************************************************************************

function hChangeDoc() as string

    '///<h1>Function to modify all documenttypes to set  the "changed" flag</h1>

   select case gApplication
   
      case "WRITER", "HTML", "MASTERDOC"
                      Kontext "DocumentWriter"
                      DocumentWriter.TypeKeys "<Return>This doc is changed!"
                      Sleep 1
                      hChangeDoc() = "Changed WRITER/HTML/MASTERDOC" 

      case "CALC"   : Kontext "DocumentCalc"
                      DocumentCalc.TypeKeys "<Down>This doc is changed!<Return>"
                      Sleep 1
                      hChangeDoc() = "Changed CALC" 

      case "DRAW"   : Kontext "DocumentDraw"
                      hRechteckErstellen ( 20, 20, 25, 25 )
                      gMouseClick ( 1, 1 )
                      Sleep 1
                      hChangeDoc() = "Changed DRAW" 

      case "IMPRESS": Kontext "DocumentImpress"
                      hRechteckErstellen ( 20, 20, 25, 25 )
                      gMouseClick ( 1, 1 )
                      Sleep 1
                      hChangeDoc() = "Changed IMPRESS" 

      case "MATH"   : SchreibenInMathdok( "b over c" )
                      hChangeDoc() = "Changed MATH" 

   end select
   
end function

'*******************************************************************************

function exitToolsOptions( bRestart as boolean )

    Kontext "OptionenDLG"
    OptionenDLG.OK()
   
    if( bRestart ) then
        call exitRestartTheOffice()
    endif
   
end function

'*******************************************************************************

function enterToolsOptionsOOoSecurity()

   call hNewDocument()
   
   ToolsOptions
   call hToolsOptions( "StarOffice" , "Security" )
   
end function

'*******************************************************************************

function enterToolsOptionsOOoView()

   call hNewDocument()
   
   ToolsOptions
   call hToolsOptions( "StarOffice" , "View" )
   
end function

'*******************************************************************************

function hIdentifyDocument( cString as string, bWarn as boolean ) as boolean

    '///<h1>Function to validate that the expected WRITER doc is the focus</h1>

    const CFN = "hIdentifyDocument::"
    dim cIdentifier as string


    ' Verify function prerequisites
    if ( gApplication <> "WRITER" ) then
        qaerrorlog( CFN & "Function only works on WRITER documents" )
        hIdentifyDocument() = false
        exit function
    endif
    
    if ( cString = "" ) then
        qaerrorlog( CFN & "Need a string for comparision as first parameter" )
        hIdentifyDocument() = false
        exit function
    endif
    
    hIdentifyDocument() = true

    kontext "DocumentWriter"
   
    ' go to the beginning of the document
    DocumentWriter.typeKeys( "<MOD1 HOME>" )
   
    ' select the first line
    DocumentWriter.typeKeys( "<SHIFT END>" )
   
    ' copy the string to the clipboard and store it into a variable 
    editcopy
    cIdentifier = getClipboardText()
   
    ' compare the string to the reference (given as parameter)
    if ( cIdentifier <> cString ) then
   
        if ( bWarn ) then
            warnlog ( CFN & "The focus is not on the expected document" )
        else
            qaerrorlog( CFN & "The focus is not on the expected document" )
        endif
        
        printlog( "Expected: " & cString )
        printlog( "Found...: " & cIdentifier )
        hIdentifyDocument() = false
      
    else
        'printlog( CFN & "The correct document is open. Good." )
    endif

end function


