'encoding UTF-8  Do not remove or change this line!
'*******************************************************************************
'*
'*  $RCSfile: entryfield.inc,v $
'*
'*  $Revision: 1.4 $
'*
'*  last change: $Author: jsk $ $Date: 2005/01/05 14:40:06 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/******************************************************************************
'*
'* owner : joerg.skottke@sun.com
'*
'* short description :
'*
'*******************************************************************************
' **
' #1 checkEntryField     ' compares the content of an EF with a reference file
' #1 setEntryField       ' copies a value from a reference file to an EF
' **
'\******************************************************************************

function  checkEntryField( _file as string , _
                            sKey as string , _
                         control as object , _
                 optional cBugID as string ) as boolean

   dim controltext as string  ' current state
   dim _controltext as string ' reference

   if ( ismissing( cBugID ) ) then cBugID = "WriteMe!"
   if ( sKey = "*" ) then sKey = control.name()

   ' lowercase the name (or alias) of the control which will be tested 
   sKey = lcase( sKey )
   
   ' get the expected setting for the control from the reference file
   _controltext = lcase( hGetFileData( _file , skey ) )
   
   ' if the reference file specifies that the control should be disabled
   ' the routine tries to access it - expecting to fail. In this case we write
   ' a string into the EF
   if ( _controltext <> "disabled" ) then
   
      if ( control.exists()  and _
           control.IsVisible() and _
           control.IsEnabled() ) then

         controltext = lcase( control.getText() )
         keycompare( controltext , _controltext , sKey , cBugID )
         checkEntryField() = control.isEnabled()
      
      else

         warnlog( "Control <" & sKey & "> could not be accessed." )
         
      endif

   else 
   
      if ( control.IsEnabled() ) then
         warnlog( "The control should be disabled but it is not: " & sKey )
      endif
      
   endif

end function

'*******************************************************************************

function  setEntryField( _file as string , _
                          sKey as string , _
                       control as object , _
             optional bverbose as boolean ) as string

   ' this is the text that will be written into the entryfield
   dim _controltext as string

   if ( ismissing( bverbose ) ) then bverbose = true
   if ( sKey = "*" ) then sKey = lcase(  control.name() )

   ' get the string from the reference file
   _controltext = lcase( hGetFileData( _file , sKey ) )
   
   if ( _controltext <> "disabled" ) then
   
      ' we can only access the control if it is present + visible
      if ( control.exists() and _
           control.IsVisible() and _
           control.IsEnabled() ) then

         control.setText( lcase( _controltext ) )
         setEntryField() = _controltext
         
         if ( bverbose ) then printlog( "     * " & sKey )
         
      else

         warnlog( "Control <" & sKey & "> is not accessible." )
         
      endif
      
   else

      if ( control.IsEnabled() ) then
         warnlog( "The control should be disabled but it is not: " & sKey )
      endif

   endif

end function
