'encoding UTF-8  Do not remove or change this line!
'*******************************************************************************
'*
'*  $RCSfile: listcreator.inc,v $
'*
'*  $Revision: 1.2 $
'*
'*  last change: $Author: jsk $ $Date: 2005/04/19 15:00:52 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*\
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/******************************************************************************
'*
'*  owner : joerg.skottke@sun.com
'*
'*  short description : Automatic creation of many reference lists
'*
'*******************************************************************************
'**
' #1 tCreateLists ' Automatic creation of many reference lists
'**
'\******************************************************************************

testcase tCreateLists

    dim clLangList( 30 ) as string    ' list containg the installed languages
    dim clLangScheme( 30 ) as string  ' list containing the localized language-names
    
    ' this is where the reference files will be written to
    dim cSavePath as string
        cSavePath = gOfficePath & "user\work\langswitch" 
        cSavePath = convertpath( cSavePath )
        
    ' integer expressions for languages
    dim iCurrentLang as integer
    dim iLangCount as integer
    dim iLangCast as integer
    dim iStartLanguage as integer
    
    printlog( "" )
    printlog( "Writing new reference-files to: " & cSavePath
    printlog( "Copy new files from save-path to load-path to use them. " & _
              "Remember to edit the 'uilang'-files, e.g. 01=English (English)."
    printlog( "" )

    iStartLanguage = iSprache
    
    ' load the language-scheme (localized language-names)
    ' the scheme must be loaded initially to set the office into a defined state,
    ' which is: Language switched to the first language in the List. In order to 
    ' do so we need to know the name of the first language since they are in 
    ' alphabetical order.
    hLoadLangScheme( clLangScheme(), iStartLanguage )
    listprint( clLangScheme() , "clLangScheme() in tCreateLists()" )

    ' get the number of installed languages and a list of those
    iLangCount = hGetInstalledLanguages( clLangList() )
    listprint( clLangList() , "clLangList() in tCreateListst" )
    
    listsort( clLangList() ) 
    listprint( clLangList() , "clLangList() in tCreateListst" )
        
    
    for iCurrentLang = 1 to iLangCount

        printlog( "" )
        printlog( "Current UI-Language: " & clLangList( iCurrentLang ) )
        
        ' cast string to int (string = "01" -> int = 1)
        iLangCast = val( clLangList( iCurrentLang ) )
        'printlog( "iLangCast in tCreateLists = " & iLangCast

        ' switch UI-Language, re-casting int to string
        'hSetUILanguage( clLangScheme() , iLangCast )
        hSwitchToLanguage( clLangList( iCurrentLang ), clLangScheme()  )
        
        ' load the language-scheme (localized language-names) from file
        hLoadLangScheme( clLangScheme(), iLangCast )        
       
        ' create UI-string-list in local workdir (calls hGetLangStrings())
        hSaveLangStrings( cSavePath , iLangCast )
            
        ' create the lists in local workdir
        hSaveLangScheme( cSavePath , iLangCast )

        ' create filterlists for some office-versions
        CreateFilterNamesList( "569" )
        CreateFilterNamesList( "645" )
        CreateFilterNamesList( "680" )
        CreateFilterNamesList( "current" )
    
   next iCurrentLang 

   printlog( "" )
   printlog( "Reset office to default language" )
   hLoadLangScheme( clLangScheme(), iSprache )
   hSetUILanguage( clLangScheme() , iStartLanguage )


endcase
