'encoding UTF-8  Do not remove or change this line!
'*******************************************************************************
'*
'*  $RCSfile: pkgmgr_tools.inc,v $
'*
'*  $Revision: 1.1 $
'*
'*  last change: $Author: jsk $ $Date: 2005/06/09 12:00:22 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/******************************************************************************
'*
'*  owner : joerg.skottke@sun.com
'*
'*  short description : Tools used for the PackageManager-UI
'*
'*******************************************************************************
'**
' #1 hAddPackage             ' Add a package vie Package-Manager-UI
' #0 hRemovePackageGeneric   ' Not used yet, should replace hRemovePackage
' #1 hRemovePackage          ' Remove a package from the Package-Manager-UI
'**
'\******************************************************************************

function hAddPackage( cFile as string, optional bClose as boolean ) as string

    '///<h1>Add a package to "My Macros" using the Package-Manager-UI</h1>
    '///<ul>
    
    dim iWait as integer ' increment-variable 
    dim cPkgName as string
    
    ' Do not close the Dialog by default
    if ( ismissing( bClose ) ) then bClose = false
    
    '///<li>Open the Package-Manager UI</li>
    printlog( "Open the Package-Manager-UI" )
    ToolsPackageManager
    
    '///<li>Make sure the first item in thelist is selected</li>
    printlog( "Select the first item" )
    kontext "packagemanager"
    BrowsePackages.select( 1 )
    BrowsePackages.typeKeys( "<UP>" )
    
    '///<li>Click the 'Add' button</li>
    printlog( "Click the 'Add' button" )
    Add.click()
    sleep( 1 )

    '///<li>Insert the full path to the package</li>
    kontext "generalfiledialog"
    Dateiname.setText( cFile )
    sleep( 1 )
    
    '///<li>Click the Open-Button</li>
    printlog( "Click the 'Open' button" )
    oeffnen.click()
    
    '///<li>Wait for the package to be added, this may take a few seconds</li>
    printlog( "Importing package, allowing 15 seconds for that" )
    for iWait = 1 to 15 
        try
            ' handle errors such as "package already installed"
            printlog( "Look for any messagebox" )
            kontext "active" 
            if ( active.exists() ) then
                warnlog( "Unexpected Active: " & active.gettext() )
                active.ok()
            endif
            
            ' try to access the treelist. If this works, the dialog has the focus
            printlog( "Walk upwards in the packages-list" )
            kontext "packagemanager"
            BrowsePackages.typeKeys( "<UP>" )
            iWait = 16
            printlog( "Importing package has finished." )
        catch
            printlog( "Importing package: Waiting another second to complete" )
            sleep( 1 )
        endcatch
    next iWait
    
    kontext "packagemanager"
    wait( 100 )
    
    '///<li>check whether the package has been added or not</li>
    printlog( "Select the first node below 'My Macros'" )
    BrowsePackages.TypeKeys( "<RIGHT>" )
    wait( 100 )
    BrowsePackages.TypeKeys( "<DOWN>" )
    wait( 100 )
    
    cPkgName = BrowsePackages.getText() 
    printlog( "Name of the package: " & cPkgName )
    hAddPackage() = cPkgName
    
    ' the package should be enabled by default. if this is not the case,
    ' try to set it enabled and warn. 
    if ( enable.isEnabled() ) then  
        enable.click()
	warnlog( "Apparently the package was installed with the DISABLED " & _
	         "attribute by default. This should not happen" )
    endif
        		 

    
    '///<li>Optional: Close the Package Manager if needed</li>
    if ( bClose ) then
        try
            sleep( 1 )
            kontext "packagemanager"
            
            sleep( 1 )
            kontext "packageManager"
            printlog( "Close the Package Manager" )
            if ( packagemanager.exists() ) then
                packagemanager.close()
                sleep( 2 )
            else
                warnlog( "Focus is NOT on packagemanager" )
            endif
        catch
            warnlog( "Closing packagemanager-UI failed, cannot recover" )
            call exitRestartTheOffice()
        endcatch
    endif
    
    '///</ul>
     
end function

'*******************************************************************************

function hRemovePackageGeneric( cName as string, bDel as boolean)

    ' This function either disables or completely uninstalls a package using the
    ' Package-Manager-UI. bDel = true means the package is to be uninstalled.
    '///<h1>Remove a package using the Package-Manager-UI</h1>
    '///<ul>
    
    dim iPos as integer

    '///<li>Open the Package-Manager UI</li>
    printlog( "Open the Package-Manager-UI" )
    ToolsPackageManager
    
    '///<li>Select the package</li>
    printlog( "Select the the package" )
    kontext "packagemanager"
    hSelectTopNode( BrowsePackages )
    hExpandNode( BrowsePackages , 0 )
    iPos = hSelectNodeByName( BrowsePackages , cName )
    printlog( "******* " & iPos )
    
    '///<li>Disbale or uninstall the package</li>
    '///<li> verify that the node does no longer exist/is disabled</li>
    try
        if ( bDel ) then
            printlog( "Press the remove-button" )
        
            remove.click()
            sleep( 5 )
        
            hSelectNode( BrowsePackages , iPos )
            if ( BrowsePackages.getSelText() <> cName ) then
                printlog( "Package has been removed" )
            else
                warnlog( "Package is still installed" )
            endif

        else
            printlog( "Press the disable-button" )
            disable.click()
            sleep( 1 )
            ' there is currently no way to verify that disabling really worked.
        endif
    catch
        warnlog( "The requested function is unavailable" )
    endcatch
    
    '///<li>Close the Package-Manager-UI</li>
    kontext "packagemanager"
    PackageManager.close()
    
    '///</ul>

end function    

'*******************************************************************************

function hRemovePackage( cName as string )

    ' this function is deprecated. It is only used to remove the first package
    ' listed in the user-section of the package manager. 

    'set kontext to the PackageManager

    kontext "packagemanager"
    'enter the treelistbox to select the package which shall be removed
    BrowsePackages.select(1)
    wait( 500 )
    BrowsePackages.typeKeys( "<UP>" )
    wait( 500 )
    BrowsePackages.typeKeys( "<RIGHT>" )
    wait( 500 )
    BrowsePackages.typeKeys( "<DOWN>" )
    sleep( 5 )         'the added package should now be selected...
    'removing the package

    if ( BrowsePackages.getText() = cName ) then
        printlog( " * Removing package" )
        remove.click()
    else
        warnlog( "An unknown package is selected for deletion, aborting" )
    endif
    
    sleep( 1 )
    kontext "PackageManager"
    try
        PackageManager.close()
    catch
        warnlog( "Crash when closing PackageManager" )
    endcatch
    
    
end function

