'encoding UTF-8  Do not remove or change this line!
'*******************************************************************************
'*
'*  $RCSfile: radiobutton.inc,v $
'*
'*  $Revision: 1.2 $
'*
'*  last change: $Author: jsk $ $Date: 2004/07/09 11:35:24 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/******************************************************************************
'*
'* owner : joerg.skottke@sun.com
'*
'* short description :
'*
'*******************************************************************************
' **
' #1 checkRadioButtons ' check a group of RBs where the sel. RB is given by number
' #1 checkRadioButton  ' check a singe RB where the state is specified directly
' **
'\******************************************************************************

function checkRadioButtons( _file as string  , _
                             sKey as string  , _
                         control1 as object  , _
                         control2 as object  , _
                optional control3 as object  , _
                optional control4 as object ) as integer

   ' this function checks if the correct radiobutton of a group is selected.
   ' at least two radiobuttons must be provided, the third and fouth are optional.
   ' The value for sKey in the reference file must be of type integer

   dim _sItem as string
   dim _iItem as integer

   ' lowercase sKey for comparision
   sKey = lcase( sKey )

   ' get the reference value for sKey as string
   _sItem = hGetFileData( _file , sKey )

   ' cast it to int
   _iItem = val( _sItem )

   ' check which one of the up to four radiobuttons is selected.
   select case _iItem

      case 1 :

               if ( control1.isChecked() = true ) then
                  checkRadioButtons() = true
                  printlog( "   * Radiobutton 1 selected: ok" )
               else
                  warnlog( "The wrong radiobutton is selected" )
               endif

      case 2 :

               if ( control2.isChecked() = true ) then
                  checkRadioButtons() = true
                  printlog( "   * Radiobutton 2 selected: ok" )
               else
                  warnlog( "The wrong radiobutton is selected" )
               endif

      case 3 :

            if ( isMissing( control3 ) = false ) then
               if ( control3.isChecked() = true ) then
                  checkRadioButtons() = true
                  printlog( "   * Radiobutton 3 selected: ok" )
               else
                  warnlog( "The wrong radiobutton is selected" )
               endif
            else
               warnlog( "referencing to non-existing control." )
               checkRadioButtons() = false
            endif

      case 4 :

            if ( isMissing( control4 ) = false ) then
               if ( control4.isChecked() = true ) then
                  checkRadioButtons() = true
                  printlog( "   * Radiobutton 4 selected: ok" )
               else
                  warnlog( "The wrong radiobutton is selected" )
               endif
            else
               warnlog( "referencing to non-existing control." )
               checkRadioButtons() = false
            endif

       case else

           warnlog( "Maximum of four connected radiobuttons allowed." )
           checkRadioButtons() = false

   end select

end function

'*******************************************************************************

function checkRadioButton( _file as string , _
                            sKey as string , _
                         control as object ) as boolean

   ' a wrapper. The routine is identical to checkCheckBox.

    checkRadioButton = checkCheckBox( _file , sKey , control )

end function
