'encoding UTF-8  Do not remove or change this line!
'*******************************************************************************
'*
'*  $RCSfile: security_tools.inc,v $
'*
'*  $Revision: 1.5 $
'*
'*  last change: $Author: jsk $ $Date: 2005/06/23 13:48:58 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/******************************************************************************
'*
'*  owner : joerg.skottke@sun.com
'*
'*  short description : Tools to ease testing of security related funtionality
'*
'*******************************************************************************
'**
' #1 hSetPasswordRecommendation ' Recommend password protection on save on/off
' #0 hWarnAtSaveOrSend ' check or uncheck to warn at save or send
' #1 hSetMacroSecurity ' switch between security levels in Tools/Options
'**
'\******************************************************************************

function hSetPasswordRecommendation( bEnable as boolean ) as boolean

    ' This tiny little function switches password recommendation on (=true)
    ' or off (=false) and returns the prior state

    printlog( "" )
    printlog( " * Open Tools/Options" )
    ToolsOptions
                                                                                                                               
    printlog( " * Go to the security page" )
    hToolsOptions( "STAROFFICE" , "SECURITY" )

    printlog( " * Get the current config for password recommendation" )
    
    kontext "TabSecurity"
    if ( RecommendPasswordProtectionOnSaving.isChecked() ) then
        hSetPasswordRecommendation() = true
    else
        hSetPasswordRecommendation() = false
    endif
                                            
                                                                                       
    if ( bEnable ) then
        printlog( " * Enable password recommendation" )
        RecommendPasswordProtectionOnSaving.check()
    else
        printlog( " * Disable password recommendation" )
        RecommendPasswordProtectionOnSaving.uncheck()
    endif

    Kontext "ToolsOptionsDlg"
    ToolsOptionsDlg.ok()

end function

'******************************************************************************

function hWarnAtSaveOrSend( iMode as integer ) as boolean

     '///<h1>Toggle security option warn at saving or sending of documents</h1>

     ' Imode: 0 = uncheck, 1 = check, -1 = default (uncheck)
     
     ' pessimistic assumption
     hWarnAtSaveOrSend() = false
     
     ToolsOptions

     hToolsOptions( "StarOffice" , "Security" )

     printlog( "" )
     printlog( " * Toggling Checkbox: Warn at saving or sending of documents" )

     kontext "TabSecurity"

     select case iMode
     case -1 : SavingOrSendingDocuments.uncheck()
               printlog( "   [-1] Resetting to default (disabled)" )
               sleep( 1 )
               if ( not SavingOrSendingDocuments.isChecked() ) then
                    hWarnAtSaveOrSend() = true
               endif

     case 0  : SavingOrSendingDocuments.uncheck()
               printlog( "   [0] Disabling warning" )
               sleep( 1 )
               if ( not SavingOrSendingDocuments.isChecked() ) then
                    hWarnAtSaveOrSend() = true
               endif

     case 1  : SavingOrSendingDocuments.check()
               sleep( 1 )
               printlog( "   [1] Enabling warning" )
               if ( SavingOrSendingDocuments.isChecked() ) then
                    hWarnAtSaveOrSend() = true
               endif
     case else
               warnlog( "Invalid parameter specified to hWarnAtSaveOrSend( int )" )
               printlog( "Your input: " & iMode & " Allowed are -1,0,1" )
               hWarnAtSaveOrSend() = false
     end select

     kontext "OptionenDlg"
     OptionenDlg.OK()

end function

'*******************************************************************************

function hSetMacroSecurity( ilevel ) as integer

    ' this function changes the macro security level from 0 (Low) to 
    ' 3 (Very high) and returns the prior state.
    ' a window document needs to be open.
    
    ToolsOptions
    
    hToolsOptions( "Staroffice" , "Security" )
    
    Kontext "TabSecurity"
    MacroSecurity.click()
    sleep( 1 )
    
    Kontext
    active.setpage TabSecurityLevel
    
    Kontext "TabSecurityLevel"
    sleep( 1 )
    
    ' get the current state and assign as function returnvalue
    if ( veryhigh.ischecked() ) then
        hSetMacroSecurity() = 3
        wait( 500 )
    elseif( high.ischecked() ) then
        hSetMacroSecurity() = 2
        wait( 500 )
    elseif( medium.ischecked() ) then
        hSetMacroSecurity() = 1
        wait( 500 )
    elseif( low.ischecked() ) then
        hSetMacroSecurity() = 0
        wait( 500 )
    else
        warnlog( "What?" )
    endif
    
    ' set the new security level
    select case iLevel
    case 0 : 
        low.check()
        printlog( " * setting macro security level to low" )
    case 1 : 
        medium.check()
        printlog( " * setting macro security level to medium" )
    case 2 : 
        high.check()
        printlog( " * setting macro security level to high" )
    case 3 : 
        veryhigh.check()
        printlog( " * setting macro security level to very high" )
    end select
    wait( 500 )
    
    TabSecurityLevel.ok()
    sleep( 1 )
    
    exitToolsOptions( false )
    
end function

