'encoding UTF-8  Do not remove or change this line!
'*******************************************************************************
'*
'*  $RCSfile: spadmin_tools.inc,v $
'*
'*  $Revision: 1.5 $
'*
'*  last change: $Author: jsk $ $Date: 2005/04/07 06:50:57 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/******************************************************************************
'*
'* owner : joerg.skottke@sun.com
'*
'* short description : helper functions for SPAdmin
'*
'*******************************************************************************
'**
' #0 hGetPrinterPosition ' get the index of a given printer in the list
' #0 hDelPrinter         ' deletes a printer by name
' #0 hGetSPAdminPath     ' find out where spadmin is located
' #0 hShutdownOffice     ' closes all docs and exits the backing window
' #0 hOpenSpadmin        ' starts the SpAdmin in automation mode
' #0 hWaitForSpAdmin     ' wait for SpAdmin to open or get the focus
' #0 hCreateFaxDevice    ' creates a default fax device 
'**
'\******************************************************************************

function hGetPrinterPosition( cName as string, bWarn as boolean ) as integer
  
   dim iCurrentQueue as integer
   dim bFound as boolean
   dim iPrinterCount as integer
       iPrintercount = LBPrinters.getItemCount()

   Kontext "SpAdmin"
   bFound = false   
                
   for iCurrentQueue = 1 to iPrinterCount
   
      wait( 200 )
      
      LBPrinters.select( iCurrentQueue )
      
      if ( LBPrinters.getseltext() = cName ) then
         hGetPrinterPosition() = iCurrentQueue
         iCurrentQueue = iPrinterCount + 1
         bFound = true
      endif
         
   next iCurrentQueue
   
   if ( not bFound and bWarn ) then
      hGetPrinterPosition() = 0
      qaerrorlog( "The specified printer queue could not be found in the list" )
   endif
   
   Kontext "SpAdmin"
                   
end function      

'*******************************************************************************

function hDelPrinter( cPrinterName as string ) as integer

   ' delete a printer-queue from the printers-list by name. Only exact matches
   ' will be removed.

   dim iPrinterPos as integer

   Kontext "SpAdmin"
   iPrinterPos = hGetPrinterPosition( cPrinterName , true )
   
   if ( iPrinterPos > 0 ) then
   
      LBPrinters.select( iPrinterPos )
   
      PBRemove.click()
      sleep( 2 )
      
      try
         Kontext "Active"
         if ( active.exists() ) then
            Active.Yes()
         else
            warnlog( "Confirmation-dialog to delete printer is missing" )
         endif
      catch
         warnlog( "Unable to confirm printer deletion" )
      endcatch
      
   else
   
      warnlog( "Unable to delete the specified printer queue" )
      
   endif
   
   Kontext "SpAdmin"


end function            

'*******************************************************************************

function hGetSpadminPath() as string

   ' find out where SPAdmin is located. 

   dim sPath as string
   
   sPath = gNetzOfficePath & "program\spadmin"
   sPath = convertpath( sPath ) 

   printlog( " * Using SPAdmin from: " & sPath

   hGetSpadminPath() = sPath
   
end function

'*******************************************************************************

function hShutdownOffice() as integer

   dim iOpenDocs as integer
       iOpenDocs = getDocumentCount()
   dim iThisDoc as integer
       
   ' close all open documents
   for iThisDoc = 1 to iOpenDocs
   
      call hCloseDocument()
      
   next iThisDoc
   
   ' set the return value
   hShutdownOffice() = getDocumentCount()
   
   ' shutdown the backing window
   qaerrorlog( "#i46293# The slot FileExit does not work without parameters" )
   FileExit( "SynchronMode", TRUE )
   sleep( 5 )
   
   ' NOTE: Do not test if the offic is closed. In order to do so, the testtool
   '       would start the office ... X-)
   
   printlog( "" )
   printlog( " * The office should have been closed by now." )
   
end function

'*******************************************************************************

function hOpenSpadmin() as boolean

   dim cSpadminPath as string
       cSpadminPath = hGetSpadminPath()
       
   ' start SPAdmin in automation mode. 
   try
      start( cSpadminPath  , "-enableautomation" )
      hOpenSpAdmin() = hWaitForSpAdmin()
   catch
      warnlog( "SpAdmin doesn't appear to be open. The Test will fail" )
   endcatch

end function

'********************************************************************************

function hWaitForSpAdmin() as boolean
   
   dim iTries as integer
   dim bOpen as boolean
   
   for iTries = 1 to 10 
   
       kontext "SpAdmin"
       
       try
   
	       if ( SpAdmin.exists() ) then
    	       printlog( " * SpAdmin is open. Good." )
        	   bOpen = true
	           exit for
    	   else
        	   sleep( 1 )
	           bOpen = false
    	   endif
       catch
       endcatch
       
   next iTries
   
   if ( not bOpen ) then
       warnlog( "SpAdmin is not Open, the test cannot continue" )
       printlog( "Maybe 'FileExit' does not work?" )
   endif       
   
   hWaitForSpadmin() = bOpen

end function

'*******************************************************************************

function hCreateFaxDevice( cName as string ) as boolean

   ' quickly greates a fax device accepting all defaults
   printlog( " * creating a default fax device" )

   Kontext "SpAdmin"
   PBNewPrinter.click()
   
   Kontext "SpPrinterWizard"
   PBNext.click()
   
   Kontext "SpPrinterWizard"
   PBNext.click()

   Kontext "TabPWQueueCommand"
   CBCommand.setText( """(PHONE)""" )
   
   Kontext "SpPrinterWizard"
   PBNext.click()
   
   Kontext "TabPWPrinterName"
   EFFaxName.setText( cName )
   
   Kontext "SpPrinterWizard"
   SpPrinterWizard.ok()
   
   sleep( 1 )

   Kontext "SpAdmin"
   if ( hgetPrinterPosition( cName ) <> 0 ) then
      hCreateFaxDevice() = true
   else
      hCreateFaxDevice() = false
      warnlog( "The fax device could not be created or SPAdmin is not open." )
   endif
   
   
end function      
