'encoding UTF-8  Do not remove or change this line!
'*******************************************************************************
'*
'*  $RCSfile: wizards.inc,v $
'*
'*  $Revision: 1.9 $
'*
'*  last change: $Author: jsk $ $Date: 2005/06/03 07:01:20 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/******************************************************************************
'*
'*  owner : joerg.skottke@sun.com
'*
'*  short description : helper functions for the wizards
'*
'*******************************************************************************
'**
' #1 hOpenWizardWithMenu  ' helper functions to open wizards via menu
' #1 hFinishWizard        ' helper function to close wizards
' #1 hGetWizardParams     ' Retrieve location of wizard within the menustructure
' #1 hWaitForWizard       ' function that waits for a wizard to open
' #1 hSetTemplateSavePath ' set destination-path using file-save from wizard
' #1 hNextPage            ' go to the next page of the wizard
'**
'\******************************************************************************

function hOpenWizardWithMenu( cType as string ) as integer

    '///<h1>Function to open a wizard via menu</h1>
    '///This functions opens the Letter, Fax and any other Wizard using the 
    '///menu. Returnvalues are:
    '///<ul>
    '///<li>0 = the expected wizard is open</li>
    '///<li>1 = no wizard is open</li>
    '///<li>2 = the incorrect wizard is open</li>
    '///<li>3 = the requested wizard is unknown to this function</li>
    '///</ul>
    
    dim iMainMenuPosition as integer   ' position in the main menu
    dim iMenuPosition as integer       ' the position of the menuentry
    dim iWizardMenuPosition as integer ' the position of the wizards menu
    dim iWizardID as integer           ' a unique number to identify the wizard
    dim iWait as integer               ' time of the wizard to open
    dim iOpen as integer               ' identifier for the open dialog

    hOpenWizardWithMenu() = 0

    ' find out where in the menustructure the wizards are located
    printlog( "Requested Wizard: " & cType )
    iWizardID = hGetWizardParams( cType , "ID" )
    iMainMenuPosition = hGetWizardParams( cType , "MAIN" )
    iMenuPosition = hGetWizardParams( cType , "SUB" )
    iWizardMenuPosition = 4
    
    
    try
        kontext "DocumentWriter"
        hUseMenu()

        ' This is the 'File' menu
        printlog( "Open Menu at pos " & iMainMenuPosition )
        hMenuSelectNr( iMainMenuPosition )
        sleep( 2 )
  
        ' if we are in the filemenu the wizards are below a submenu
        if ( iMainMenuPosition = 1 ) then
            printlog( "Select wizards-submenu at pos " & iWizardMenuPosition )
            hMenuSelectNr( iWizardMenuPosition )
        endif
    
        ' try to click the menuentry where we expect the wizard
        printlog( "Select " & cType & " wizard at pos " & iMenuPosition )
        hMenuSelectNr( iMenuPosition )
    catch
        ' we end up here, when the menuitems could not be accessed
        hOpenWizardwithMenu() = 1
        exit function
    endcatch
    
    ' wait for a wizard to open, iOpen is the number of the menuitem
    iOpen = hWaitForWizard()
    
    ' Verify that the correct wizard is open. iOpen should match iMenuPosition
    ' This works because the menu-positions are unique. BEWARE!
    if ( iOpen <> iWizardID ) then
            
        warnlog( "Incorrect Wizard is open, did the menu-order change?" )
                
        hFinishWizard( 2 ) 
        hOpenWizardWithMenu() = 2

    else
    
        hOpenWizardWithMenu() = 0
                
    endif    
    
end function

'*******************************************************************************

function hFinishWizard( iMode as integer ) as boolean

    '///<h1>Finish wizards</h1>
    '///This function is used to close Fax-, Agenda- and Letterwizard
    '///the context is set dynamically, there is no errorhandling other than
    '///returning false on failure. There are two modes:
    '///<ol>
    '///<li>Using the Finish-button</li>
    '///<li>Using the Cancel-button</li>
    '///</ol>
    '///The function prints the required time to the log.
    
    ' handle possible errors when invoking this function
    if ( ( iMode < 1 ) or ( iMode > 2 ) ) then
        warnlog( "hFinishWizard()::invalid iMode = " & iMode )
        hFinishWizard() = false
        exit function
    endif

    dim iWait as integer
    dim brc as boolean 
        brc = false
    
    for iWait = 1 to 5
    
        sleep( 1 )

        Kontext "AutopilotLetter"
        if ( AutopilotLetter.exists() ) then
            select case iMode
            case 1 : FinishButton.click()
            case 2 : AutopilotLetter.cancel()
            end select
            brc = true
            exit for
        endif

        Kontext "AutopilotFax"
        if ( AutopilotFax.exists() ) then
            select case iMode
            case 1 : FinishButton.click()
            case 2 : AutopilotFax.cancel()
            end select
            brc = true
            exit for
        endif
        
        Kontext "AutopilotAgenda"
        if ( AutopilotAgenda.exists() ) then
            select case iMode
            case 1 : createButton.click()
            case 2 : cancelButton.click()
            end select
            brc = true
            exit for
        endif    
        
        Kontext "MailMergeWizard" 
        if ( MailMergeWizard.exists() ) then
            select case iMode
            case 1 : MailMergeWizard.OK()
            case 2 : MailMergeWizard.Cancel()
            end select
            brc = true
            exit for
        endif            

    next iWait 
    
    if ( brc ) then
        printlog( "Closed wizard after " & iWait & " seconds." )
        hFinishWizard() = true
    else
        warnlog( "No (known) wizard is present to be closed" )
        hFinishWizard() = false
    endif

end function   

'*******************************************************************************

function hGetWizardParams( cType as string, cParam as string ) as integer

    '///<h1>Function to retrieve the location of a wizard in the menu</h1>
    '///This small function returns either the Main-Menu (usually 'File')
    '///or the submenu where the item to start a specific wizard is located
    '///Currently all wizards are implemented but not tested.

    dim iMainMenuPosition as integer
    dim iMenuPosition as integer
    dim iWizardID as integer
    
    cType = ucase( cType )
    cParam = ucase( cParam )

    ' set the position of the main menu where the wizard is located "MAIN"
    ' set the position below the main-menu "SUB"
    ' set an unique id for the wizard (ID <> SUB!) "ID"
    select case cType
    case "MAILMERGE"    : iMainMenuPosition = 7
                          iMenuPosition = 11
                          iWizardID = 11
    case "LETTER"       : iMainMenuPosition = 1
                          iMenuPosition = 1
                          iWizardID = 1
    case "FAX"          : iMainMenuPosition = 1
                          iMenuPosition = 2
                          iWizardID = 2
    case "AGENDA"       : iMainMenuPosition = 1
                          iMenuPosition = 3
                          iWizardID = 3
    case "PRESENTATION" : iMainMenuPosition = 1
                          iMenuPosition = 4
                          iWizardID = 4
    case "WEBPAGE"      : iMainMenuPosition = 1
                          iMenuPosition = 5
                          iWizardID = 5
    case "DOCCONV"      : iMainMenuPosition = 1
                          iMenuPosition = 6
                          iWizardID = 6
    case "EUROCONV"     : iMainMenuPosition = 1
                          iMenuPosition = 7
                          iWizardID = 7    
    case "ADDRESS"      : iMainMenuPosition = 1
                          iMenuPosition = 8 
                          iWizardID = 8                               
    case else 
        iMainMenuPosition = 0
        iMenuPosition = 0
    end select
    
    
    
    select case cParam
    case "MAIN"   : hGetWizardParams() = iMainMenuPosition
    case "SUB"    : hGetWizardParams() = iMenuPosition
    case "ID"     : hGetWizardParams() = iWizardID
    case else     : hGetWizardParams() = 0
    end select
    
end function

'*******************************************************************************

function hWaitForWizard() as integer

    '///<h1>Function that waits for a specific wizard to open</li>
    '///<p>Cycle through the (defined) dialogs for a wizard to open</p>
    '///<ul>
    '///<li>Test autopilot letter</li>
    '///<li>Test autopilot fax</li>
    '///<li>Test autopilot agenda</li>
    '///<li>Test autopilot mailmerge (currently not used)</li>
    '///<li>Return the ID of the wizard to the calling program (0=failure)</li>
    '///</ul>

    dim iOpen as integer
    dim iWait as integer

    ' Loop until the wizard is open, max 10 seconds
    for iWait = 1 to 10
     
        sleep( 1 )
        iOpen = 0
    
        kontext "AutopilotLetter"
        if ( AutopilotLetter.exists() ) then
            printlog( "Autopilot Letter is open" )
            iOpen = hGetWizardParams( "LETTER" , "ID" )
            exit for
	    endif

        kontext "AutopilotFax"
        if ( AutopilotFax.exists() ) then
            printlog( "Autopilot Fax is open" )
            iOpen = hGetWizardParams( "FAX" , "ID" )
            exit for
        endif 
        
        kontext "AutopilotAgenda"
        if ( AutopilotAgenda.exists() ) then
            printlog( "Autopilot Agenda is open" )
            iOpen = hGetWizardParams( "AGENDA" , "ID" )
            exit for
        endif  
        
        Kontext "MailMergeWizard"
        if ( MailMergeWizard.exists() ) then
            printlog( "Mailmerge Wizard is open" )
            iOpen = hGetWizardParams( "MAILMERGE" , "ID" )
            exit for
        endif
 
    next iWait
    
    hWaitForWizard() = iOpen
    
end function    

'*******************************************************************************

function hSetTemplateSavePath( cFile as string ) as integer

    '///<h1>Function to set the template save-path</h1>
    '///<ul>
    '///<li>click on the save-as button</li>
    '///<li>Enter a filename</li>
    '///<li>Save the file</li>
    '///<li>Return errorcode to calling program</li>
    '///</ul>    
    dim iErr as integer

    printlog( "   * open the file-save-dialog" )
    SaveAsButton.click()
    sleep( 2 )

    kontext "SpeichernDlg"
    if ( not speichernDlg.exists() ) then
        qaerrorlog( "#i49515# FileSave dialog does not open" )
        iErr = 1 
    endif

    ' only go on if we have no error so far.
    if ( iErr = 0 ) then
        call dialogtest( SpeichernDlg )
    
        printlog( "   * name the file" )
        DateiName.setText( cFile )
    
        printlog( "   * save the template" )
        speichern.click()
        sleep( 2 )
    endif

    
    hSetTemplateSavePath() = iErr
    
end function

'*******************************************************************************

function hHandleSaveError() as integer

    '///<h1>Function to handle errors while saving Templates created by wizards</h1>
    '///<ul>
    '///<li>check for unexpected messagebox: file could not be saved</li>
    '///<li>Close the dialog either with YES or OK</li>
    '///<li>Report back the errorcode to the calling program</li>
    '///</ul>
    dim iErr as integer

    sleep( 2 )
    iErr = 0
    

    kontext "active"
    if ( active.exists() ) then
        warnlog( "Unexpected MsgBox: " & active.getText() )
        try
            active.ok()
            iErr = 2
        catch
            active.yes()
            iErr = 1
        endcatch
        sleep( 1 )
        
    endif
    
    hHandleSaveError() = iErr
    
    
end function

'*******************************************************************************

function hNextPage( cPageName as string ) as boolean

    dim iWait as integer

    if ( not NextButton.exists() ) then
        warnlog( "The Next>> Button does not exist in this context" )
        hNextPage() = false
        exit function
    endif
    
    
    printlog( "Next page: " & cPageName )
    hNextPage() = false
    for iWait = 1 to 10

        if ( NextButton.isEnabled() ) then
             NextButton.click()
             hNextPage() = true
             exit for
        else
             printlog( "Waiting..." )
             wait( 250 )
        endif
        
    next iWait    
    
end function    
