'encoding UTF-8  Do not remove or change this line!
'*******************************************************************************
'*
'*  $RCSfile: f_updt_letterwizard.inc,v $
'*
'*  $Revision: 1.14 $
'*
'*  last change: $Author: jsk $ $Date: 2005/06/03 08:06:51 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/******************************************************************************
'*
'*  owner : joerg.skottke@sun.com
'*
'*  short description : Letter Wizard
'*
'*******************************************************************************
'**
' #1 tUpdtLetterWizard ' Letter Wizard
'**
'\******************************************************************************

testcase tUpdtLetterWizard

    '///<h1>Update test for the letter wizard</h1>
    '///<i>Based on the Letter Wizard Specification 2004/10/03</i>
    '///<p>The special thing about this test is that it accesses all pages.</p>
    '///<ul>

    dim cTemplateName as string
    dim cTemplatePath as string
    dim iErr as integer

    cTemplateName = "myLetterTemplate.ott"
    cTemplatePath = gOfficePath & "user\template\" & cTemplateName
    cTemplatePath = convertpath( cTemplatePath )
        
    hDeleteFile( cTemplatePath )

    '///<li>open the letterwizard using the menu, page design opens</li>
    iErr = hOpenWizardWithMenu( "LETTER" )
    if ( iErr = 1 ) then
        warnlog( "#i46909# Wizard crashes/does not open" )
        goto endsub
    endif    

    kontext "Autopilotletter"    
    printlog( " * Page: Page Design" )
    call dialogtest( AutopilotLetter )

    '///<li>select to create a business letter</li>
    printlog( "   * select a business letter" )
    Business.check()
    sleep( 1 )

    '///<li>do not accept to overwrite the default template</li>
    kontext "active"
    if ( active.exists( 1 ) ) then
        warnlog( "   * refusing to change the default template" )
        active.cancel()
    endif
    sleep( 3 )

    '///<li>select business style (here: 2. entry in listbox)</li>
    kontext "Autopilotletter"    
    BusinessStyle.select( 2 )
    sleep( 2 )

    '///<li>do not accept to overwrite the default template</li>
    kontext "active"
    if ( active.exists( 1 ) ) then
        warnlog( "   * refusing to change the default template" )
        active.cancel()
    endif
    sleep( 3 )

    '///<li>check to add a letterhead</li>
    kontext "AutopilotLetter"
    LetterHead.Check()

    '///<li>click next to get to the letterhead-page</li>
    hNextPage( "2. Letterhead Layout" )

    kontext "AutopilotLetter"
    call dialogtest( AutopilotLetter )
    
    '///<li>check to add a logo</li>
    printlog( "   * check to add logo" )
    Logo.check()
    
    '///<li>change all metrics for the logo</li>
    printlog( "   * change the metrics of the logo" )
    LogoHeight.settext( "4" )
    LogoWidth.settext( "4" )
    LogoXpos.settext( "1" )
    LogoYpos.settext( "1" )
    
    '///<li>check to add own address</li>
    printlog( "   * check to add own address" )
    ReturnAddress.check()
    
    '///<li>change the metrics of the addressfield</li>
    printlog( "   * change the metrics of the address-field" )
    AddressHeight.settext( "4" )
    AddressWidth.settext( "4" )
    AddressXpos.settext( "1" )
    AddressYpos.settext( "1" )
    
    '///<li>check to show the return-address in envelope window</li>
    printlog( "   * check to show return-address in envelope window" )
    ReturnAddressCompany.check()
    
    '///<li>make sure the footer checkbox is *not* selected</li>
    printlog( "   * UNcheck to add a footer" )
    IncludeFooter.unCheck()
    
    '///<li>The footer-height box should be disabled at this point</li>
    printlog( "   * change the height" )
    if ( FooterHeight.isEnabled() ) then
        warnlog( "FooterHeight should not be enabled in this configuration" )
    endif
    
    hNextPage( "3. Printed Items" )

    kontext "AutopilotLetter"
    call dialogtest( AutopilotLetter )    
    
    '///<li>set letterpage norm to the second entry</li>
    printlog( "   * change letterformat to the second entry" )
    LetterPageNorm.select( 2 )
    
    '///<li>change the salutation to the second entry</li>
    printlog( "   * change salutation to the second entry" )
    ListSalutation.select( 2 )
    
    '///<li>change complimentary close to second entry</li>
    printlog( "   * change Complimentary Close to second entry" )
    ListGreetings.select( 2 )
    hNextPage( "4. Recipient and sender" )

    kontext "AutopilotLetter"
    call dialogtest( AutopilotLetter )
    hNextPage( "5. Footer" )

    kontext "AutopilotLetter"
    call dialogtest( AutopilotLetter )    
    
    '///<li>insert some text into the footer-field</li>
    printlog( "   * enter some text as footer" )
    TextFooter.settext( "Goodmorning Vietnaaaaam!" )
    
    '///<li>check to include it on any second page</li>
    printlog( "   * check Include only on second ..." )
    IncludeFromPage2.check()
    hNextPage( "6. Name and location" )

    kontext "AutopilotLetter"
    call dialogtest( AutopilotLetter )   
    
    '///<li>name the template for further usage</li>
    printlog( "   * name the template for further usage" )
    TemplateName.setText( cTemplateName )
    hSetTemplateSavePath( cTemplatePath )
    
    '///<li>click the 'finish' button</li>
    hFinishWizard( 1 )
    
    iErr = hHandleSaveError()
    if ( iErr = 1 ) then
        kontext "AutopilotLetter"
        hFinishWizard( 1 )
    endif
    
    '///<li>close the document</li>     
    call hCloseDocument()    
    
    '///<li>Delete the template from the userdirectory</li>
    hDeleteFile( cTemplatePath )
    '///</ul>

endcase


