'encoding UTF-8  Do not remove or change this line!
'*******************************************************************************
'*
'*  $RCSfile: f_updt_spadmin.inc,v $
'*
'*  $Revision: 1.5 $
'*
'*  last change: $Author: jsk $ $Date: 2005/02/17 09:50:58 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/******************************************************************************
'*
'* owner : joerg.skottke@sun.com
'*
'* short description : updatetest for the printer configuration
'*
'*******************************************************************************
'**
' #1 t_updt_spadmin ' Go through all pages/dialogs of SpAdmin
' #0 TestNewPrinter ' create a new fax printer queue
' #0 TestProperties ' go through the properties for the fax-printer
' #0 TestRename     ' open the -rename- dialog
'**
'\******************************************************************************

testcase t_updt_spadmin

   '///<h3>Update test for the SpAdmin printer configuration tool</h3>
   '///<ul>
   '///<li>Open SpAdmin</li>
   '///<li>Create a new fax-device</li>
   '///<li>Step through the pages of the printer wizard, finish it</li>
   '///<li>Open the properties of the new queue</li>
   '///<li>Step through all the tabs (5)</li>
   '///<li>Close the dialog</li>
   '///<li>Open the <i>Rename</i> dialog, test and close it</li>
   '///<li>Open the fonts dialog, open <i>import</i>, close the dialogs</li>
   '///</ul>

   const CPRINTER = "tt-testprinter"
   
   hShutdownOffice()
   
   if ( hOpenSpadmin() ) then
   
      ' this deletes the printer queue if it exists
      if ( hGetPrinterPosition( CPRINTER , false ) > 0 ) then
         printlog( "   * The printer exists, it will be deleted" )
         hDelPrinter( CPRINTER )
         printlog( "" )
      endif
      
      if ( hWaitForSpAdmin ) then
          ' this creates a new fax device
          TestNewPrinter( CPRINTER )
      endif
      
      if ( hWaitForSpAdmin ) then
          ' this steps through the properties of the newly created device
          TestProperties( CPRINTER )
      endif
      
      if ( hWaitForSpAdmin ) then
          ' this renames the fax-device
          TestRename( CPRINTER )
      endif
         
      ' this deletes the fax device
      hDelPrinter( CPRINTER )
         
   endif
   
endcase

'*******************************************************************************

sub TestNewPrinter( cPrinter as string )

   dim iWait as integer

   printlog( " * New Printer" )
   Kontext "SPAdmin"
   PBNewPrinter.click()
   sleep( 1 )
   
   printlog( "   * select 'Connect a Fax Device'" )
   Kontext "TabPWDeviceSelector"
   call dialogtest( TabPWDeviceSelector )
   RBFax.check()
   
   printlog( "   * next ->" )
   Kontext "SpPrinterWizard"
   PBNext.click()
   sleep( 1 )
   
   printlog( "   * accept the default driver (first entry)" )
   Kontext "TabPWFaxDriverSelector"
   call dialogtest( TabPWFaxDriverSelector )
   
   printlog( "   * next ->" )
   Kontext "SpPrinterWizard"
   PBNext.click()
   sleep( 1 )

   printlog( "   * enter '(PHONE)' as queue" )
   Kontext "TabPWQueueCommand"
   call dialogtest( TabPWQueueCommand )
   CBCommand.setText( """(PHONE)""" )
   
   printlog( "   * next ->" )
   Kontext "SpPrinterWizard"
   PBNext.click()
   sleep( 1 )
   
   printlog( "   * enter a name for the fax-printer" )
   Kontext "TabPWPrinterName"
   call dialogtest( TabPWPrinterName )
   EFFaxName.setText( cPrinter )
   sleep( 2 )
   
    printlog( "   * Finish" )
    for iWait = 1 to 3
        try
            Kontext "SpPrinterWizard"
            SpPrinterWizard.ok()
            iWait = 4 ' leave the loop
        catch
            printlog( "Waiting for dialog" )
            sleep( 1 )
            if ( iWait = 3 ) then
                qaerrorlog( "Could not click 'finish' on printerwizard" )
            endif
        endcatch
    next iWait

   printlog( "" )
      
end sub

'*******************************************************************************

sub TestProperties( cPrinter as string )

   dim iPrinterPos as integer

   kontext "SpAdmin"
   iPrinterPos = hGetPrinterPosition( CPRINTER , true )
   
   LBPrinters.select( iPrinterPos )
         
   PBProperties.click()
   sleep( 1 )
   printlog( " * Properties for the new fax device" )
        
   kontext 
   active.setpage TabSPACommand
      
   kontext "TabSPACommand"
   printlog( "   * Tab: Command" ) 
   call dialogtest( TabSPACommand )
         
   kontext 
   active.setpage TabSPAPaper
      
   kontext "TabSPAPaper"
   printlog( "   * Tab: Paper" ) 
   call dialogtest( TabSPAPaper )
         
   kontext 
   active.setpage TabSPADevice
      
   kontext "TabSPADevice"
   printlog( "   * Tab: Device" ) 
   call dialogtest( TabSPADevice )
         
   kontext 
   active.setpage TabSPAFontReplacement
      
   kontext "TabSPAFontReplacement"
   printlog( "   * Tab: FontReplacement" ) 
   call dialogtest( TabSPAFontReplacement )
         
   kontext 
   active.setpage TabSPAOther
      
   kontext "TabSPAOther"
   printlog( "   * Tab: Other" ) 
   call dialogtest( TabSPAOther )
         
   printlog( "   * close Properties" )
   TabSPAOther.cancel()
   
   printlog( "" )
      
end sub

'*******************************************************************************

sub TestRename( cPrinter as string )

   Kontext "SpAdmin"
   LBPrinters.select( hGetPrinterPosition( CPRINTER , true ) )
   sleep( 1 )
      
   printlog( " * Open 'Rename' dialog" )
   PBRename.click()
   sleep( 1 )
      
   Kontext "SPRenamePrinterDLG"
   call dialogtest( SPRenamePrinterDLG )
   printlog( "   * Close 'Rename' dialog" )
   SPRenamePrinterDLG.cancel()
   
   printlog( "" )

end sub

'*******************************************************************************

sub TestFonts( cPrinter as string )

   printlog( " * Open 'Fonts...' dialog" )
   Kontext "SpAdmin"
   PBFonts.click()
   sleep( 1 )
      
   printlog( "   * Test the font-dialog" )
   Kontext "SPFontNameDLG"
   call dialogtest( SPFontNameDLG )
      
   printlog( "   * Press 'Add ...'" )
   PBAdd.click()
   sleep( 1 )
      
   printlog( "   * Test the import-dialog" )
   kontext "SPFontImportDLG"
   call dialogtest( SPFontImportDLG )
      
   printlog( "   * close import dialog" )
   SPFontImportDLG.cancel()
      
   Kontext "SPFontNameDLG"
   printlog( "   * close fonts-dialog" )
   SPFontNameDLG.ok()
   sleep( 1 )

end sub
